import { Service, ServiceConfiguration } from '@cross-lab-project/soa-client';
import { DataChannel } from '@cross-lab-project/soa-client';
import { PeerConnection } from '@cross-lab-project/soa-client';
import { TypedEmitter } from 'tiny-typed-emitter';
import { ParameterDescription, ParameterServiceEvent, ParameterServiceSetupEvent } from './messages';
type ServiceType = 'https://api.goldi-labs.de/serviceTypes/parameter';
declare const ServiceType: ServiceType;
export interface MessageServiceConfiguration extends ServiceConfiguration {
    serviceType: ServiceType;
    parameters: ParameterDescription[];
}
interface ParameterService__ProducerEvents {
    setup: (event: ParameterServiceSetupEvent) => void;
}
export declare class ParameterService__Producer extends TypedEmitter<ParameterService__ProducerEvents> implements Service {
    serviceType: "https://api.goldi-labs.de/serviceTypes/parameter";
    serviceId: string;
    serviceDirection: import("@cross-lab-project/soa-client").ServiceDirection;
    channel?: DataChannel;
    constructor(serviceId: string);
    getMeta(): {
        serviceType: "https://api.goldi-labs.de/serviceTypes/parameter";
        serviceId: string;
        serviceDirection: import("@cross-lab-project/soa-client").ServiceDirection;
    };
    setupConnection(connection: PeerConnection, serviceConfig: ServiceConfiguration): void;
    updateParameter(parameter: string, value: number): Promise<void>;
}
interface ParameterService__ConsumerEvents {
    update: (event: ParameterServiceEvent) => void;
}
export declare class ParameterService__Consumer extends TypedEmitter<ParameterService__ConsumerEvents> implements Service {
    serviceType: "https://api.goldi-labs.de/serviceTypes/parameter";
    serviceId: string;
    serviceDirection: import("@cross-lab-project/soa-client").ServiceDirection;
    parameterDescriptions: ParameterDescription[];
    constructor(serviceId: string, parametersDescriptions: ParameterDescription[]);
    getMeta(): {
        serviceType: "https://api.goldi-labs.de/serviceTypes/parameter";
        serviceId: string;
        serviceDirection: import("@cross-lab-project/soa-client").ServiceDirection;
        parameters: ParameterDescription[];
    };
    setupConnection(connection: PeerConnection, serviceConfig: ServiceConfiguration): void;
    handleData(data: string | Blob | ArrayBuffer | ArrayBufferView): void;
}
export {};
//# sourceMappingURL=parameter_service.d.ts.map